"""Given a list, sort it using insertion sort.

For example::

    >>> from random import shuffle
    >>> alist = list(range(1, 11))

    >>> shuffle(alist)
    >>> insertion_sort(alist)
    [1, 2, 3, 4, 5, 6, 7, 8, 9, 10]

    >>> shuffle(alist)
    >>> insertion_sort(alist)
    [1, 2, 3, 4, 5, 6, 7, 8, 9, 10]

    >>> shuffle(alist)
    >>> insertion_sort(alist)
    [1, 2, 3, 4, 5, 6, 7, 8, 9, 10]
"""


def insertion_sort(alist):
    """Given a list, sort it using insertion sort."""

    # START SOLUTION

    for i in range(1, len(alist)):
        # For each item in the list, starting at the second, find out
        # how far to the left it goes--as soon as we find a number
        # smaller than it, we've gone far enough back

        j = i - 1
        while j >= 0 and alist[j] > alist[i]:
            j -= 1
        j += 1

        # now j in the position where we should move i to, and we should
        # put everything over to the right after that

        if j != i:
            alist[j:i + 1] = alist[i:i + 1] + alist[j:i]

    return alist

    # END SOLUTION


if __name__ == '__main__':
    import doctest
    if doctest.testmod().failed == 0:
        print("\n*** ALL TESTS PASSED. NICE SORTING!\n")
